## Definition of Mgen

n=3
codimY=8

load "dimHorb_common.sage"


## Projection on the normal space of Y in X

def NormalProjection(M):
    L=[]
    for i in [3,4,5,6] : 
    	for j in [0] : L.append(M[i,j]);
    for i in [7,8] : 
    	for j in [1,2] : L.append(M[i,j]);
    return(L) 

## La base C0

I3=IdentityMatrix(3)
s1=MatriceNulle(n); s1[0,1]=1;s1+=s1.transpose();
s2=MatriceNulle(n); s2[1,2]=1;s2+=s2.transpose();
s3=MatriceNulle(n); s3[2,0]=1;s3+=s3.transpose();
a1=MatriceNulle(n); a1[0,1]=1;a1-=a1.transpose();
a2=MatriceNulle(n); a2[1,2]=1;a2-=a2.transpose();
a3=MatriceNulle(n); a3[2,0]=1;a3-=a3.transpose(); 
d1=MatriceNulle(n); d1[0,0]=1;
d2=MatriceNulle(n); d2[2,2]=1;
baseRandom=[SkewSymRandom(n),I3,SymRandom(n),s2,s3,d1,d2,a2,a3]


x1=1; 
x2=-1; 

a1=matrix(3,[0,1,x1,-1,0,x2,-x1,-x2,0])


baseHand=[a1,I3,s1,s2,s3,d1,d2,a2,a3]
P=Base2Matrix(baseRandom)
print(P)

## FINAL VERIFICATION

print('We want',codimY)
print('And the rank is', FinalRank(P,codimY,n))


P=Base2Matrix(baseHand)
print(P)

## FINAL VERIFICATION

print('We want',codimY)
print('And the rank is', FinalRank(P,codimY,n))


print(latex(a1))

print(s1)
	
    	







